; sawbench/theme.jl

;; Copyright (C) 1999 Jess Bravo lvarez <jba@pobox.com>

;; raise-lower button definition

  (def-frame-class raise-lower-button '((cursor . exchange))
     (bind-keys raise-lower-button-keymap
         "Button1-Off" 'raise-lower-window))

(let*

  (

;; the font

    (font "-*-lucida-medium-r-normal-*-*-100-*-*-p-*-*")

;; images

    (title-images (list (make-image "t2-.png")
                        (make-image "t2.png")))

    (iconify-images (list (make-image "t3-.png")
                          (make-image "t3.png") nil
                          (make-image "t3b.png")))

    (maximize-images (list (make-image "t4-.png")
                           (make-image "t4.png") nil
                           (make-image "t4b.png")))

    (close-images (list (make-image "t1-.png")
                        (make-image "t1.png") nil
                        (make-image "t1b.png")))

    (s-close-images (list (make-image "t1-b.png")
                          (make-image "t1-c.png") nil
                          (make-image "t1b.png")))

    (raise-lower-images (list (make-image "t5-b.png")
                        (make-image "t5-c.png") nil
                        (make-image "t5b.png")))

    (s-raise-lower-images (list (make-image "t5-.png")
                          (make-image "t5.png") nil
                          (make-image "t5b.png")))

    (horizontal-border-images (list (make-image "bb6-.png")
                                    (make-image "bb6.png")))

    (vertical-border-images (list (make-image "bb8-.png")
                                  (make-image "bb8.png")))

    (bottom-left-images (list (make-image "b7-.png")
                              (make-image "b7.png")))

    (bottom-right-images (list (make-image "b5-.png")
                               (make-image "b5.png")))


;; frame layout

    (frame
     `(

    ;; title

        ((background . ,title-images)
         (foreground . ("black"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (top-edge . -14)
         (left-edge . 20)
         (right-edge . 68)
         (class . title)
        )

    ;; raise-lower button

        ((background . ,raise-lower-images)
         (top-edge . -14)
         (right-edge . -4)
         (class . raise-lower-button)
        )

    ;; iconify button

        ((background . ,iconify-images)
         (top-edge . -14)
         (right-edge . 44)
         (class . iconify-button)
        )

    ;; maximize button

        ((background . ,maximize-images)
         (top-edge . -14)
         (right-edge . 20)
         (class . maximize-button)
        )

    ;; close button

        ((background . ,close-images)
         (top-edge . -14)
         (left-edge . -4)
         (class . close-button)
        )

    ;; left border

        ((background . ,vertical-border-images)
         (top-edge . 0)
         (bottom-edge . 0)
         (left-edge . -4)
         (class . left-border)
        )

    ;; right border

        ((background . ,vertical-border-images)
         (top-edge . 0)
         (bottom-edge . 0)
         (right-edge . -4)
         (class . right-border)
        )

    ;; bottom border

        ((background . ,horizontal-border-images)
         (bottom-edge . -4)
         (right-edge . 0)
         (left-edge . 0)
         (class . bottom-border)
        )

    ;; bottom-left corner

        ((background . ,bottom-left-images)
         (bottom-edge . -4)
         (left-edge . -4)
         (class . bottom-left-corner)
        )

    ;; bottom-right corner

        ((background . ,bottom-right-images)
         (bottom-edge . -4)
         (right-edge . -4)
         (class . bottom-right-corner)
        )
      )
    )

    (shaped-frame
     `(

    ;; title

        ((background . ,title-images)
         (foreground . ("black"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (top-edge . -14)
         (left-edge . 20)
         (right-edge . 68)
         (class . title)
        )

    ;; raise-lower button

        ((background . ,s-raise-lower-images)
         (top-edge . -14)
         (right-edge . -4)
         (class . raise-lower-button)
        )

    ;; iconify button

        ((background . ,iconify-images)
         (top-edge . -14)
         (right-edge . 44)
         (class . iconify-button)
        )

    ;; maximize button

        ((background . ,maximize-images)
         (top-edge . -14)
         (right-edge . 20)
         (class . maximize-button)
        )

    ;; close button

        ((background . ,s-close-images)
         (top-edge . -14)
         (left-edge . -4)
         (class . close-button)
        )

      )
    )

    (transient-frame
     `(

    ;; title

        ((background . ,title-images)
         (foreground . ("black"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (top-edge . -14)
         (left-edge . 20)
         (right-edge . 20)
         (class . title)
        )

    ;; raise-lower button

        ((background . ,raise-lower-images)
         (top-edge . -14)
         (right-edge . -4)
         (class . raise-lower-button)
        )

    ;; close button

        ((background . ,close-images)
         (top-edge . -14)
         (left-edge . -4)
         (class . close-button)
        )

    ;; left border

        ((background . ,vertical-border-images)
         (top-edge . 0)
         (bottom-edge . 0)
         (left-edge . -4)
         (class . left-border)
        )

    ;; right border

        ((background . ,vertical-border-images)
         (top-edge . 0)
         (bottom-edge . 0)
         (right-edge . -4)
         (class . right-border)
        )

    ;; bottom border

        ((background . ,horizontal-border-images)
         (bottom-edge . -4)
         (right-edge . 0)
         (left-edge . 0)
         (class . bottom-border)
        )

    ;; bottom-left corner

        ((background . ,bottom-left-images)
         (bottom-edge . -4)
         (left-edge . -4)
         (class . bottom-left-corner)
        )

    ;; bottom-right corner

        ((background . ,bottom-right-images)
         (bottom-edge . -4)
         (right-edge . -4)
         (class . bottom-right-corner)
        )
      )
    )

    (shaped-transient-frame
     `(

    ;; title

        ((background . ,title-images)
         (foreground . ("black"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (top-edge . -14)
         (left-edge . 20)
         (right-edge . 20)
         (class . title)
        )

    ;; raise-lower button

        ((background . ,s-raise-lower-images)
         (top-edge . -14)
         (right-edge . -4)
         (class . raise-lower-button)
        )

    ;; close button

        ((background . ,s-close-images)
         (top-edge . -14)
         (left-edge . -4)
         (class . close-button)
        )
      )
    )
  )

;; frame definition

  (add-frame-style 'sawbench
    (lambda (w type)
      (case type
            ((default) frame)
            ((transient) transient-frame)
            ((shaped) shaped-frame)
            ((shaped-transient) shaped-transient-frame)
      )
    )
  )

)
